/*
 * QCMCamLibrary
 * Moteur javascript de QCMCam
 * By Sebastien COGEZ 2018
 */
var reponses = {0: "C", 1: "D", 2: "A", 3: "B"};
var canvas2, context2, interval, video = false, qFocusOn = 0, animation = false, qlarge = 500, nbQ = 1, editor, intervaldecompte, canvas, context, videoReady = false;
var videoSources = [];
var selectedSource = 0;
var selectedSourceResolution = -1;
var webcamResolutions = [[480, 360], [640, 360], [640, 480], [704, 480], [720, 480], [800, 480], [800, 600], [960, 720], [1024, 768], [1280, 720], [1280, 800], [1280, 960], [1280, 1024], [1600, 1200], [1920, 1080]];
var intervalSession, sessionId, myWindow, reponseAction, wait = {nexted: false, updateClasse: false, addQuestion: false};
var usersChangeDetected = false, reponsesChangeDetected = false, changeQuestionFocus = false, changeNombreQuestions = false; // pour tracer le changement de la liste des utilisateurs pendant la session avec un portable/tablette
var stopSessionRequest = false;// variable pour indiquer la demande d'arrêt de la session avec le smartphone
var stylesheets = {};
var validrep = {};// permet de valider une réponse donnée, pour tenter d'éviter les fausses détections assez nombreuses.
var datas = {}, datasdemo = {}, qdatas = {}, qreponses = {}, totaux = {"A": 0, "B": 0, "C": 0, "D": 0}, eleves = {}, compteids = [], hdConstraints = {}, scan = false, namesvisible = true;
// correspondances des codes aruco avec les id de l'application, tout en prévenant les symétries d'image
// deux jeux de codes sont disponibles, ceux codés sur 5 bits, et ceux codés sur 4 bits (plus visibles).
var correspondances = {'p5': {743: 1, 878: 1, 366: 2, 741: 2, 735: 3, 990: 3, 734: 4, 478: 5, 733: 5, 727: 6, 862: 6, 350: 7, 725: 7, 719: 8, 974: 8, 590: 9, 710: 9, 314: 10, 689: 10, 246: 11, 636: 11, 635: 12, 950: 12, 438: 13, 633: 13,
        374: 14, 629: 14, 118: 15, 628: 15, 627: 16, 822: 16, 486: 17, 621: 17, 619: 18, 934: 18, 422: 19, 617: 19, 358: 20, 613: 20, 607: 21, 982: 21, 406: 22, 601: 22, 595: 23, 790: 23, 454: 24, 589: 24, 583: 25, 838: 25,
        326: 26, 581: 26, 498: 27, 573: 27, 434: 28, 569: 28, 370: 29, 565: 29, 443: 30, 978: 30, 466: 31, 541: 31, 535: 32, 850: 32, 509: 33, 507: 34, 957: 34, 189: 35, 504: 35, 445: 36, 505: 36, 502: 37, 637: 37, 381: 38, 501: 38,
        495: 39, 1005: 39, 494: 40, 749: 40, 491: 41, 941: 41, 237: 42, 492: 42, 487: 43, 877: 43, 365: 44, 485: 44, 150: 45, 600: 45},
    'p4': {106: 1, 107: 2, 110: 3, 111: 4, 122: 5, 123: 6, 126: 7, 127: 8, 154: 9, 155: 10, 158: 11, 159: 12, 166: 13, 167: 14, 169: 15, 170: 16, 171: 17, 173: 18, 174: 19, 175: 20, 182: 21, 183: 22, 185: 23, 186: 24, 187: 25, 189: 26, 190: 27, 191: 28, 218: 29, 219: 30, 222: 31, 223: 32, 230: 33, 231: 34, 233: 35, 234: 36, 235: 37, 237: 38, 238: 39, 239: 40, 246: 41, 247: 42, 249: 43, 250: 44, 251: 45},
    'p3': {1: 1, 2: 2, 4: 3, 5: 4, 6: 5, 7: 6, 8: 7, 10: 8, 11: 9, 13: 10, 16: 11, 17: 12, 18: 13, 19: 14, 20: 15, 21: 16, 27: 17, 28: 18, 30: 19, 32: 20, 33: 21, 34: 22, 35: 23, 36: 24, 38: 25, 39: 26, 40: 27, 42: 28, 45: 29, 49: 30, 50: 31, 52: 32, 54: 33, 55: 34, 56: 35, 57: 36, 59: 37}};
// Par défaut, on prend le jeu des codes 5x5;
var typeCode = 4;
var corres = correspondances["p" + typeCode];
var collegeinit = {
    "GP1": {
        "1": "Participant 1",
        "2": "Participant 2",
        "3": "Participant 3",
        "4": "Participant 4",
        "5": "Participant 5",
        "6": "Participant 6",
        "7": "Participant 7",
        "8": "Participant 8",
        "9": "Participant 9",
        "10": "Participant 10",
        "11": "Participant 11",
        "12": "Participant 12",
        "13": "Participant 13",
        "14": "Participant 14",
        "15": "Participant 15",
        "16": "Participant 16",
        "17": "Participant 17",
        "18": "Participant 18",
        "19": "Participant 19",
        "20": "Participant 20",
        "21": "Participant 21",
        "22": "Participant 22",
        "23": "Participant 23",
        "24": "Participant 24",
        "25": "Participant 25",
        "26": "Participant 26",
        "27": "Participant 27",
        "28": "Participant 28",
        "29": "Participant 29",
        "30": "Participant 30",
        "effectif": 30
    },
    "GP2": {
        "1": "Di Alain",
        "2": "Onyme Anne",
        "3": "Chaud Artie",
        "4": "Malaki Ben",
        "5": "Onxa Cécile",
        "6": "Obscur Clair",
        "7": "Zore Dino",
        "8": "Cicode David",
        "9": "Coptaire Eli",
        "10": "Rice Edith",
        "11": "Oposte Fidel",
        "12": "Gafatoy Fabien",
        "13": "Mansoif Gérard",
        "14": "Héparbal Gilles",
        "15": "Bol Guy",
        "16": "Perret Inès",
        "17": "Peuplu Jean",
        "18": "Instant Justin",
        "19": "Dioci Kelly",
        "20": "Chevée Lyna",
        "21": "Dévous Laurent",
        "22": "Nord Paul",
        "23": "Tounet Patrice",
        "24": "Sagratte Sandra",
        "25": "Stickey Sophie",
        "26": "Jasmin Théo",
        "27": "Hate Tom",
        "28": "Timaitre Vincent",
        "29": "Elnypoivre Yannis",
        "30": "Débobe Yvan",
        "effectif": 30
    }
};
function changeCode(num) {
    if (num === 4 || num === 5) {
        typeCode = num;
        corres = correspondances["p" + num];
        alert("Mode " + num + " bits activé.");
        return true;
    } else
        return false;
}
var qexport = "";
// fonction permettant de detecter la disponibilité de stockat local des données
function storageAvailable(type) {
    try {
        var storage = window[type],
                x = '__storage_test__';
        storage.setItem(x, x);
        storage.removeItem(x);
        return true;
    } catch (e) {
        return e instanceof DOMException && (
                // everything except Firefox
                e.code === 22 ||
                // Firefox
                e.code === 1014 ||
                // test name field too, because code might not be present
                // everything except Firefox
                e.name === 'QuotaExceededError' ||
                // Firefox
                e.name === 'NS_ERROR_DOM_QUOTA_REACHED');
    }
}
if (storageAvailable('localStorage')) { // on récupère le numéro de la caméra sélectionnée la dernière fois.
    if (localStorage.camera > 0)
        selectedSource = localStorage.camera;
}
function afficheAccueil(truefalse) {
  if(truefalse === undefined){
     truefalse = true;
  }
    if (document.getElementById("messageacceuil").className === "cache" && truefalse) {
        document.getElementById("messageacceuil").className = "";
        document.getElementById("listeeleves").className = "cache";
    } else {
        document.getElementById("messageacceuil").className = "cache";
        document.getElementById("listeeleves").className = "";
}
}
/*
 * pleinEcran : passe la page en plein écran.
 * @returns {undefined}
 */
function pleinEcran() {
    if (screenfull.enabled) {
        screenfull.request();
    }
}
function lancerDemo() {
    var intro = introJs();
    intro.onbeforechange(function (targetElement) {
        var btnclick = ["btnadd", "btnkey", "btna", "btnb", "btng", "btnop"];
        var tb = ["A", "B", "C", "D"], alea;
        if (targetElement.id === "classes") {
            targetElement.value = "GP1";
            chargeClasse("GP1");
        } else if (targetElement.id === "goodAnswer") {
            alea = Math.floor(Math.random() * 4);
            targetElement.value = "C";
            setGoodAnswer("C");
        } else if (btnclick.indexOf(targetElement.id) > -1) {
            targetElement.click();
            if (targetElement.id === "btna" && scan === true) {
                // on met des fausses réponses
                var i = 0;
                for (i = 1; i <= 30; i++) {
                    alea = Math.floor(Math.random() * 4);
                    datasdemo[i] = {vote: tb[alea], nbvotes: 1};
                    datas = datasdemo;
                    updateVotes();
                    compteValeurs();
                }
            }
        }
    });
    intro.onchange(function (tElem) {
        if (tElem.id === "questionsContener") {
            // creation d'un contenu faux
            setTimeout(function () {
                CKEDITOR.instances['editor' + qFocusOn].setData("<h2>Combien font 8×7 ?</h2><p>A. 87</p><p>B. 54</p><p>C. 56</p><p>D. 63");
            }, 1000);
        }
        if (tElem.id === "btnadd") {
            setTimeout(function () {
                CKEDITOR.instances['editor' + qFocusOn].setData("<h3>Quel est l&#39;inverse de <span class=\"math-tex\">\\(\\dfrac37\\)</span> ?</h3><p>A.&nbsp;<span class=\"math-tex\">\\(-\\dfrac37\\)</span></p><p>B.&nbsp;<span class=\"math-tex\">\\(-\\dfrac73\\)</span></p><p>C.&nbsp;<span class=\"math-tex\">\\(\\dfrac73\\)</span></p><p>D.&nbsp;<span class=\"math-tex\">\\(\\dfrac{1}{\\dfrac73}\\)</span></p>");
            }, 1500);
        }
    });
    intro.onafterchange(function (tElem) {
        if (tElem.id === "btnop") {
            document.getElementById('btng').click();
        }
    });
    intro.setOptions({"skipLabel": "stop", "doneLabel": "Compris", "nextLabel": " > ", "prevLabel": " < ",
        steps: [
            {intro: "Par où commencer ?"},
            {intro: "Distribuez les cartes réponses aléatoirement"},
            {element: "#classes", intro: "Chargez une classe factice de 30 participants"},
            {element: "#questionsContener", intro: "Editez rapidement la question"},
            {element: "#btnadd", intro: "Ajoutez éventuellement des questions"},
            {element: "#btnkey", intro: "Allumez la caméra"},
            {element: '#btna', intro: "Activez le scan des réponses et sondez les participants avec votre caméra"},
            {element: '#btna', intro: "Désactivez le scan des réponses."},
            {element: "#btnb", intro: "Affichez les statistiques des réponses"},
            {element: "#goodAnswer", intro: "Indiquez la bonne réponse"},
            {element: "#btnb", intro: "Montrez les réponses apportées par chacun. Et voilà !"},
            {intro: "Pour aller plus loin"},
            {element: "#btng", intro: "Utilisez ce boutons pour afficher plus d'options sur les questions"},
            {element: "#editionquestions", intro: "insérez, déplacez les questions, supprimez, téléchargez vos questions, indiquez la bonne réponse..."},
            {element: "#btng", intro: "Cliquez à nouveau pour fermer."},
            {element: "#btnop", intro: "ou celui-ci pour les participants"},
            {element: "#editionparticipants", intro: "Videz, créez, supprimez, éditez, téléchargez les participants"},
            {element: "#btnop", intro: "Cliquez à nouveau pour fermer."},
            {element: "#btnstats", intro: "Cliquez pour voir les stats et les télécharger"},
            {intro: "Ya plus qu'à ... !"}
        ]
    });
    intro.start();
}
/*
 * initAll : réinitialise les données de question en cours
 * @returns {nothing}
 */
function initAll(move) {
  if(move === undefined){
    move = true;
  }
    validrep = {};
    datas = {};
    totaux = {"A": 0, "B": 0, "C": 0, "D": 0};
    document.getElementById("goodAnswer").options[0].selected = 'selected';
    compteValeurs();
    if (stylesheets[qFocusOn] !== undefined && !move)
        removeStyle(qFocusOn);
    if (eleves !== undefined) {
        var nbeleves = 0;
        // on compte combien il y a d'élèves
        for (var i in eleves) {
            if (!isNaN(parseFloat(i)) && isFinite(i))
                nbeleves++;
        }
        eleves.effectif = nbeleves;
        usersShow();
}
}
/*
 * resetAll : efface toutes les données.
 * @returns {undefined}
 */
function resetAll() {
    initAll();
    for (var i in stylesheets) {
        removeStyle(i);
    }
    qdatas = {};
    // en cas de gestion avec le portable
    if (sessionId > 0) {
        usersChangeDetected = true;
    }
}
function reloadCKEDITOR() {
    for (var name in CKEDITOR.instances) {
        CKEDITOR.instances[name].destroy(true);
    }
    //CKEDITOR.inlineAll();
    var i;
    var editors = document.getElementsByClassName('question');
    for (i = 0; i < editors.length; i++) {
        CKEDITOR.inline(editors[i]);
    }
}
function setAnimationWidth() {
    setQuestionsWidth();
    updatenbQ();
    document.getElementById("animate").style.width = (nbQ * 100) + "%";
    document.getElementById("animate").style.marginLeft = (-qFocusOn * 100) + "%";
}
function htmlToElement(html) {
    var template = document.createElement('template');
    template.innerHTML = html;
    return template.content.firstChild;
}
function updatenbQ() {
    var elem = document.getElementById('animate');
    nbQ = elem.childElementCount;
}
function renameEditors(rang) {
    // si rang est fourni, on renomme les editeurs en décalant de 1 de plus
    var e;
    if (rang !== undefined) {
        for (i = nbQ - 1; i >= rang; i--) {
            e = document.getElementById("editor" + i);
            e.id = "editor" + (i + 1);
        }
    } else {
        var alldivs = document.querySelectorAll("#animate > div");
        for (i = 0; i < alldivs.length; i++) {
            alldivs[i].id = "editor" + i;
        }
        reloadCKEDITOR();
    }
}
/*
 * addQ : ajoute une question dans l'interface
 * @returns {nothing}
 */
function addQ() {
    var elem = document.getElementById('animate');
    elem.innerHTML += '<div id="editor' + nbQ + '" contenteditable="true" class="question"><h3>Question ' + (nbQ + 1) + '&nbsp;:</h3> <ol><li>&nbsp;</li></ol></div>';
    setAnimationWidth();
    reloadCKEDITOR();
    myMove("last");
    qdatas[nbQ - 1] = {};
    if (sessionId !== undefined) {
        changeNombreQuestions = true;
    }
}
/*
 * prevQ : demande l'affichage de la question précédente
 * nextQ : demande l'affichage de la question suivante
 *
 */
function prevQ() {
    if (qFocusOn === 0)
        return;
    myMove("r");
}
function nextQ() {
    if (qFocusOn === nbQ - 1)
        return;
    myMove("l");
}
function firstQ() {
    if (qFocusOn === 0)
        return;
    myMove("first");
}
function lastQ() {
    if (qFocusOn === nbQ - 1) {
        return;
    }
    myMove("last");
}
/*
 * function moreOption
 * Affiche ou cache les commandes supplémentaires pour gérer les questions/participants.
 * @returns {undefined}
 */
function moreOptions(appelant, id) {
    var elem = document.getElementById(id);
    if (elem.className === "cache") {
        // on ajoute l'écouteur de copier/Coller
        document.getElementById("importliste").addEventListener("paste", function (event) {
            importerParticipants(event.clipboardData.getData('text/plain'));
        });
        appelant.style.opacity = 0.6;
        elem.className = "";
    } else {
        elem.className = "cache";
        appelant.style.opacity = 1;
        document.getElementById("importliste").removeEventListener("paste");
    }
    if (id === "editionquestions") {
        var elem2 = document.getElementById("navigation");
        if (elem2.style.marginTop === "10px")
            elem2.style.marginTop = "-10px";
        else
            elem2.style.marginTop = "10px";
    }
}
/*
 * function supprThis
 * supprime la question affichée.
 * @returns {undefined}
 */
function supprQ() {
    var elem = document.getElementById("editor" + qFocusOn);
    var i;
    for (i = qFocusOn; i < nbQ; i++) {
        qreponses[i] = qreponses[i + 1];
    }
    if (qreponses[nbQ] !== undefined)
        delete qreponses[nbQ];
    elem.parentNode.removeChild(elem);
    setAnimationWidth();
    renameEditors();
    updateNav();
    if (sessionId !== undefined) {
        changeNombreQuestions = true;
    }
}
function insertQ() {
    // il faut changer l'id de chaque editeur qui suit celui qui va être inséré.
    renameEditors(qFocusOn);
    var div = htmlToElement('<div id="editor' + (qFocusOn) + '" contenteditable="true" class="question"><h3>Question ' + (qFocusOn + 1) + ':</h3> <ol><li>&nbsp;</li></ol></div>');
    var refNode = document.getElementById("editor" + (qFocusOn + 1));
    for (var i = nbQ - 1; i >= qFocusOn; i--) {
        qreponses[i + 1] = qreponses[i];
    }
    if (qreponses[qFocusOn] !== undefined)
        delete qreponses[qFocusOn];
    refNode.parentNode.insertBefore(div, refNode);
    setAnimationWidth();
    reloadCKEDITOR();
    updateNav();
    if (sessionId !== undefined) {
        changeNombreQuestions = true;
    }
}
function supprAllQ() {
    var elem = document.getElementById("animate");
    elem.innerHTML = '<div id="editor0" contenteditable="true" class="question"><h3>Question 1 :</h3> <ol><li>&nbsp;</li></ol></div>';
    qdatas = {};qreponses = {}; totaux = {"A": 0, "B": 0, "C": 0, "D": 0 };
    nbQ = 1;
    qFocusOn = 0;
    setAnimationWidth();
    updateNav();
    reloadCKEDITOR();
    resetAll();
    if (sessionId !== undefined) {
        changeNombreQuestions = true;
    }
}
/*
 *
 * Déplace la question avant la questions précédente
 */
function moveQLeft() {
    if (qFocusOn === 0)
        return false;
    var rtemp = qreponses[qFocusOn - 1];
    qreponses[qFocusOn - 1] = qreponses[qFocusOn];
    qreponses[qFocusOn] = rtemp;
    var elem = document.getElementById("editor" + qFocusOn);
    elem.parentNode.removeChild(elem);
    var refNode = document.getElementById("editor" + (qFocusOn - 1));
    refNode.parentNode.insertBefore(elem, refNode);
    setAnimationWidth();
    renameEditors();
    updateNav();
}
/*
 *
 * Déplace la question après la question suivante
 */
function moveQRight() {
  var rtemp, refNode;
  var elem = document.getElementById("editor" + qFocusOn);
    if (qFocusOn > nbQ - 1)
        return false;
    if (qFocusOn < nbQ - 2) {
        rtemp = qreponses[qFocusOn + 1];
        qreponses[qFocusOn + 1] = qreponses[qFocusOn];
        qreponses[qFocusOn] = rtemp;
        elem.parentNode.removeChild(elem);
        refNode = document.getElementById("editor" + (qFocusOn + 2));
        refNode.parentNode.insertBefore(elem, refNode);
    } else {
        rtemp = qreponses[qFocusOn + 1];
        qreponses[qFocusOn + 1] = qreponses[qFocusOn];
        qreponses[qFocusOn] = rtemp;
        refNode.parentNode.appendChild(elem);
    }
    setAnimationWidth();
    renameEditors();
    updateNav();
}
/*
 * updateNav : met à jour les couleurs des boutons de navigation dans les questions
 * @returns {nothing}
 */
function updateNav() {
    updatenbQ();
    if (nbQ > 1) {
        if (qFocusOn > 0) {
            document.getElementById("buttonLeft").className = "";
            document.getElementById("buttonFirst").className = "";
        } else {
            document.getElementById("buttonLeft").className = "inactiv";
            document.getElementById("buttonFirst").className = "inactiv";
        }
        if (qFocusOn < nbQ - 1) {
            document.getElementById("buttonRight").className = "";
            document.getElementById("buttonLast").className = "";
        } else {
            document.getElementById("buttonRight").className = "inactiv";
            document.getElementById("buttonLast").className = "inactiv";
        }
    }
    // si la bonne réponse a été proposée, on l'affiche
    var reponseset = qreponses[qFocusOn];
    if (reponseset !== undefined) {
        showResponses(reponseset);
        // bouton radio
        document.getElementById('R' + reponseset).checked = true;
        document.getElementById('revealanswer').className = "";
        document.getElementById("goodAnswer").className = "cache";
    } else {
        document.getElementById('R0').checked = true;
        document.getElementById('revealanswer').className = "cache";
        document.getElementById("goodAnswer").className = "";
    }
    // on met à jour l'affichage du numéro de la question
    document.getElementById("numquestion").innerHTML = (qFocusOn + 1) + "/" + nbQ;
}
/*
 * myMove : fait glisser les questions vers la droite, la gauche ou vers la dernière
 * @param {type} direction : "l" pour gauche, "r" pour right, "last" pour aller à la dernière question
 * @returns {Boolean}
 */
function myMove(direction) {
    // on prévient les pb d'animation en cours
    if (animation === true)
        return false;
    if (qFocusOn === 0 && direction === "r")
        return false;
    scanner(false);
    var elem = document.getElementById("animate");
    if (qFocusOn === nbQ - 1 && direction === "l")
        return false;
    // on prévient que l'animation est en cours, pour empêcher d'appuyer à nouveau sur le bouton et pour cesser le tick
    animation = true;
    //mLeft est le pourcentage prévu
    var mLeft = Number(elem.style.marginLeft.slice(0, -1));
    var espaceToGo = 100;
    if (direction === "last") {
        espaceToGo = 100 * (nbQ - qFocusOn - 1);
    } else if (direction === "first") {
        espaceToGo = 100 * (qFocusOn);
    }
    var pas = espaceToGo / 20;
    var pos = 0;
    var id = setInterval(frame, 1);
    function frame() {
        if (pos >= espaceToGo) {
            // l'animation est terminée.
            clearInterval(id);
            animation = false;
            // on relance la mise à jour de l'affichage de la caméra si elle est allumée
            if (video !== false) {
                tick();
            }
            // on stocke les datas de la question précédente
            qdatas[qFocusOn] = datas;
            // on change le numéro de la question en cours.
            if (direction === "l")
                qFocusOn++;
            else if (direction === "r")
                qFocusOn--;
            else if (direction === "last")
                qFocusOn = nbQ - 1;
            else if (direction === "first")
                qFocusOn = 0;
            initAll();
            // s'il y a des datas enregistrés, on les affecte.
            if (qdatas[qFocusOn] !== undefined)
                datas = qdatas[qFocusOn];
            else
                datas = {};
            updateNav();
            updateVotes();
            // si la bonne réponse a été proposée, on l'affiche
            var reponseset = qreponses[qFocusOn];
            if (reponseset !== undefined) {
                showResponses(reponseset);
                // bouton radio
                document.getElementById('R' + reponseset).checked = true;
                document.getElementById('revealanswer').className = "";
            } else {
                document.getElementById('R0').checked = true;
                document.getElementById('revealanswer').className = "cache";
            }
            compteValeurs(reponseset);
            // on lance le scan si on vient de passer à la question et que la vidéo est en route
            if (video !== false && direction === "l") {
                scanner(true);
            }
            if (sessionId !== undefined) {
                changeQuestionFocus = true;
            }
        } else {
            pos = pos + pas;
            if (direction === "l" || direction === "last")
                elem.style.marginLeft = (mLeft - pos) + '%';
            else
                elem.style.marginLeft = (mLeft + pos) + '%';
        }
    }
}
/*
 * switche entre l'affichage des réponses apportées par les élèves
 * et la liste des élèves
 * @returns {nothing}
 */
function afficheReponses(doIt) {
  if(doIt === undefined){
    doIt = true;
  }
    var btn = document.getElementById("btnb");
    if (document.getElementById('colonnes').className === "cache" && doIt) {
        document.getElementById('colonnes').className = "inline-block";
        document.getElementById('conteneureleves').className = "cache";
        btn.src = "css/img/32px/students.png";
        btn.title = "Voir les élèves (ALT+V)";
        // on arrête le scan des réponses s'il est en cours.
        if (scan)
            scanner(false);
    } else {
        document.getElementById('colonnes').className = "cache";
        document.getElementById('conteneureleves').className = "";
        btn.src = "css/img/32px/stats.png";
        btn.title = "Voir les réponses (ALT+V)";
}
}
/*
 *
 * @param {type} option : si "open" affiche la page "à propos"
 * @returns {nothing}
 */
function Infos(option) {
    if (option === "open") {
        document.getElementById("infos").className = "";
    } else {
        document.getElementById("infos").className = "cache";
    }
}
/*
 * affiche les questions ou non
 * @returns {nothing}
 */
function afficheQuestion() {
    if (document.getElementById('question').className === "cache")
        document.getElementById('question').className = "inline-block";
    else
        document.getElementById('question').className = "cache";
}
/*
 * reduireNom : réduit une chaine à la taille demandée
 * @param {type} chaine
 * @param {type} taille
 * @returns {String}
 */
function reduireNom(chaine, taille) {
    if (chaine.length <= taille)
        return chaine;
    chaine = chaine.substring(0, taille - 1) + "▫";
    return chaine;
}
function resetCollege() {
    college = Object.assign({}, collegeinit);
    peuplerSelectClasses("basic");
    document.getElementById("btnresetclasses").className = "cache";
    if (storageAvailable('localStorage')) {
        if (localStorage.college !== undefined)
            delete localStorage.college;
    }
}
/*
 * chargeEleves : récupère la liste des élèves à partir d'un fichier csv obtenu à partir de PRONOTE
 * on prend soin de bien enlever les accents dans l'entête du fichier
 * @returns {undefined}
 */
function chargeEleves(id) {
    if (storageAvailable('localStorage')) {
        if (localStorage.college !== undefined) {
            college = JSON.parse(localStorage.college);
            peuplerSelectClasses("new");
            // on affiche le bouton permettant de revenir à la liste précédente
            document.getElementById("btnresetclasses").className = "";
            return;
        }
    }
    college = Object.assign({}, collegeinit);
    peuplerSelectClasses("basic");
    return true;
}
/*
 * affiche les noms des élèves d'une classe sélectionnée.
 * @param {type} classe : chaine avec le nom de la classe à afficher
 * @returns {undefined}
 */
function chargeClasse(classe) {
    afficheAccueil(false);
    if (classe !== undefined) {
        if (college[classe] !== undefined) {
            eleves = college[classe];
            resetAll();
        } else
            document.getElementById("listeeleves").innerHTML = "Pas d'élève dans la classe " + classe;
    } else
        document.getElementById("listeeleves").innerHTML = "Pas de classe à charger";
}
/*
 * insère les noms des élèves dans le DOM
 * @returns {undefined}
 */
function usersShow() {
    var txt = "";
    for (var i in eleves) {
        if (i === "effectif")
            continue;
        if (namesvisible === true)
            txt += '<div class="eleve" id="el' + i + '"><span class="numero">' + i + "</span><span class='participant' title='" + eleves[i] + "'>" + eleves[i] + "</span></div>";
        else
            txt += '<div class="eleve" id="el' + i + '"><span class="numero">' + i + "</span><span class='participant' style='display:none;' title='" + eleves[i] + "'>" + eleves[i] + "</span></div>";
    }
    document.getElementById("listeeleves").innerHTML = txt;
}
/*
 * Met en mode édition la liste des participants
 * @param {type} elem
 * @returns {Boolean}
 */
function usersEdit(elem) {
    var participants = document.getElementsByClassName("eleve");
    if (participants.length === 0) {
        alert("Pas d'élément à éditer.");
        return false;
    }
    var i = 0, c1, c2, ceditable = "#ffe6b3", cuneditable = "#FFF", cborder = "1px dotted #333", cborderoff = "", focus = function () {
        select(this);
    }, focusoff = null;
    var editable = participants[0].childNodes[0].isContentEditable;
    if (editable) { // on sort du mode édition
        elem.style.opacity = 1;
        document.getElementById("messageedition").className = "cache";
        //sauvegarde et rechargement de la liste dans l'objet javascript

    } else { // on entre dans le mode édition
        elem.style.opacity = 0.4;
        document.getElementById("messageedition").className = "";
    }
    for (i = 0; i < participants.length; i++) {
        c1 = participants[i].childNodes[0];
        c2 = participants[i].childNodes[1];
        if (editable) {
            c1.contentEditable = false;
            c1.style.backgroundColor = cuneditable;
            c1.style.border = cborderoff;
            c1.onfocus = focusoff;
            c2.contentEditable = false;
            c2.style.backgroundColor = cuneditable;
            c2.style.border = cborderoff;
            c2.onfocus = focusoff;
        } else {
            c1.contentEditable = true;
            c1.style.backgroundColor = ceditable;
            c1.style.border = cborder;
            c1.onfocus = focus;
            c2.contentEditable = true;
            c2.style.backgroundColor = ceditable;
            c2.style.border = cborder;
            c2.onfocus = focus;
        }
    }
    if (editable) {// on sort du mode édition
        updateUsersAfterEdit();
    }
}
function updateUsersAfterEdit() {
    var participants = document.getElementsByClassName("eleve");
    if (participants.length === 0) {
        return false;
    }
    var id, nom, ok = true;
    eleves = {};
    for (i = 0; i < participants.length; i++) {
        id = Number(participants[i].childNodes[0].innerHTML);
        nom = participants[i].childNodes[1].innerHTML;
        if (eleves[id] === undefined) {
            eleves[id] = nom;
        } else {
            ok = false;
            alert("le numéro " + id + " est utilisé plusieurs fois ! changez la valeur avant de continuer.");
        }
    }
    if (ok) {
        resetAll();
    }
}
function select(elem) {
    //Create a range (a range is a like the selection but invisible)
    var range = document.createRange();
    // Select the entire contents of the element
    range.selectNodeContents(elem);
    // Don't select, just positioning caret:
    // In front
    // range.collapse();
    // Behind:
    // range.collapse(false);

    // Get the selection object
    var selection = window.getSelection();
    // Remove any current selections
    selection.removeAllRanges();
    // Make the range you have just created the visible selection
    selection.addRange(range);
}
/*
 *
 * Supprime la liste affichée des participants
 */
function usersEmtpy() {
    if (confirm("Vous êtes sur le point de supprimer la liste des participant. Confirmez-vous ?")) {
        eleves = {};
        resetAll();
    }
}
/*
 *
 * Ajoute x participants
 */
function usersAdd() {
    var nb = Number(prompt("Combien de participants voulez-vous ajouter ?"));
    if (nb === "")
        nb = 1;
    var usersNb = Object.keys(eleves).length;
    if (nb > 46 || usersNb + nb > 46) {
        alert("Votre nombre est trop grand. Vous ne devez pas dépasser 45 utilisateurs");
        return false;
    }
    var i = 0;
    var maxKey = 0, keytemp = 0;
    for (i = 0; i < usersNb; i++) {
        keytemp = Number(Object.keys(eleves)[i]);
        if (keytemp > maxKey)
            maxKey = keytemp;
    }
    for (i = 0; i < nb; i++) {
        eleves[maxKey + i + 1] = "Participant " + (maxKey + i + 1);
    }
    resetAll();
}
/*
 *
 * Supprime un participant
 */
function userDelete() {
    var id = Number(prompt("Quel est le numéro du participant que vous voulez enlever ?"));
    if (id === "") {
        return false;
    } else {
        delete eleves[id];
        usersShow();
    }
}
/*
 * affiche ou non les noms des participants
 * @returns nothing
 */
function usersToggle() {
    var i = 0;
    var noms = document.getElementsByClassName('participant');
    for (i = 0; i < noms.length; i++) {
        if (namesvisible === true) {
            noms[i].style.display = "none";
        } else {
            noms[i].style.display = "inline-block";
        }
    }
    if (namesvisible === true) {
        namesvisible = false;
        document.getElementById("btnnames").src = "css/img/32px/if_user_search_66914.png";
    } else {
        namesvisible = true;
        document.getElementById("btnnames").src = "css/img/32px/if_user_delete_66908.png";
    }
}
/*
 * Tire un utilisateur au hasard et le met en évidence quelques secondes.
 * @returns {undefined}
 */
function userAlea(type) {
    if (eleves.effectif === undefined) {
        alert("Il faut charger une classe avant\nd'interroger un élève au hasard.");
        return;
    }
    var i = 0;
    var table = [];
    for (i in datas) {
        if (Number(i) > 0) {
            if (type === undefined) {
                table.push(i);
            } else if (type && datas[i].vote === qreponses[qFocusOn]) {// bonne réponse
                table.push(i);
            } else if (!type && datas[i].vote !== qreponses[qFocusOn]) {
                table.push(i);
            }
        }
    }
    if (table.length === 0 && type === undefined) { // cas où personne n'a répondu, on pioche dans la liste des élèves
        // permet de poser une question a priori
        for (i in eleves) {
            if (Number(i) > 0)
                table.push(i);
        }
    } else if (table.length === 0) {
        alert("Personne n'ayant répondu, action impossible");
    }
    var alea = Math.floor(Math.random() * table.length);
    // on ne prend que si la personne a voté (pour éviter les absents)
    document.getElementById("el" + table[alea]).className = "eleveevident";
    setTimeout(function () {
        document.getElementById("el" + table[alea]).className = "eleve";
    }, 5000);
}
/*
 * setQuestionsWidth : calcule la largeur du div des questions
 * @returns {Boolean}
 */
function setQuestionsWidth() {
    var divs = document.getElementsByClassName("question");
    if (divs.length > 0) {
        var percentLength = 1 / divs.length * 100;
        var i = 0;
        for (i = 0; i < divs.length; i++) {
            divs[i].style.width = percentLength + "%";
        }
    }
    return true;
}

function clearImage() {
    if (context)
        context.clearRect(0, 0, canvas.width, canvas.height);
}
/*
 * met en route le scan de l'image ou le désactive
 * @returns {undefined}
 */
function scanner(doIt) {
    if (video === false)
        return false;
    var start = true;
    if (doIt === false)
        start = false;
    if (scan === true && doIt === undefined)
        start = false;
    if (start) {// démarrage du scan
        document.getElementById("btna").src = "css/img/32px/notphoto.png";
        afficheReponses(false);//on enlève l'affichage des réponses.
        scan = true;
        validrep = {};
        canvas.style.opacity = '1';
        interval = setInterval(compteValeurs, 1000);
    } else {
        document.getElementById("btna").src = "css/img/32px/photo.png";
        scan = false;
        canvas.style.opacity = '0.5';
        clearInterval(interval);
    }
}
/*
 * relance le scan des images à chaque rafraichissement
 * @returns {undefined}
 */
tick = function () {
    var ok = false;
    if (animation === true)
        return false;
    if (video.readyState === 4) {
        if (videoReady === false && video.videoWidth > 0) {
            videoReady = true;
            canvas.width = parseInt(video.videoWidth);
            canvas.height = parseInt(video.videoHeight);
            canvas.style.width = 320 + "px";
            // mise à l'échelle de la hauteur en fonction du format de la vidéo
            var hauteurImage = Math.round(320 * parseInt(video.videoHeight) / parseInt(video.videoWidth));
            canvas.style.height = hauteurImage + "px";
            // on ajuste l'affichage de la liste des participants
            document.getElementById("conteneureleves").style.marginTop = (hauteurImage - 110) + "px";
            if (videoSources.length > 1) {
                // on affiche le bouton permettant de changer de caméra
                document.getElementById("btnchangecamera").className = "";
                document.getElementById("btnportable").className = "cache";
            }
        }
        if (canvas.width > 0) {
            //snapshot
            // copie l'image venant de la caméra dans le canvas d'affichage.
            context.drawImage(video, 0, 0, canvas.width, canvas.height);
            ok = true;
        }
    }
    if (scan && ok) {
        // var imageData ici permet d'optimiser la mémoire (la variable est nouvellement déclarée à chaque fois)
        var imageData = context.getImageData(0, 0, canvas.width, canvas.height);
        var markers = detector.detect(imageData);
        drawMarkers(markers);
        affecteReponses(markers);
    }
    requestAnimationFrame(tick);
    //window.setTimeout(tick,50);
};
drawMarkers = function (markers) {
    var corners, corner, i, j, x, y, xmax, ymax;

    context.strokeStyle = "red";
    context.textAlign = "center";
    context.textBaseline = "middle";

    for (i = 0; i !== markers.length; ++i) {
        corners = markers[i].corners;
        x = Infinity;
        y = Infinity;
        xmax = -Infinity;
        ymax = -Infinity;
        context.beginPath();
        context.moveTo(corners[0].x, corners[0].y);
        context.lineWidth = 3;
        context.fillStyle = "rgba(0,0,5,0.6)";
        for (j = 0; j < 4; j++) {
            corner = corners[(j + 1) % 4];
            context.lineTo(corner.x, corner.y);
            x = Math.min(x, corner.x);
            y = Math.min(y, corner.y);
            xmax = Math.max(xmax, corner.x);
            ymax = Math.max(ymax, corner.y);
        }
        context.closePath();
        context.stroke();
        context.fill();
        // id du marker
        context.fillStyle = "white";
        context.lineWidth = 1;
        context.font = Math.max((ymax - y) / 2) + "px Arial"; // defaut : 25 px
        if (corres[markers[i].id] !== undefined)
            context.fillText(corres[markers[i].id], (x + xmax) / 2, (y + ymax) / 2);
        else
            context.fillText("# " + markers[i].id + " #", (x + xmax) / 2, (y + ymax) / 2);
    }
};
affecteReponses = function (markers) {
    if (markers.length === 0)
        return false;
    else {
        var len = markers.length;
        for (i = 0; i < len; i++) {
            affecte(corres[markers[i].id], derterminateResponse(markers[i].corners));
        }
        updateVotes();
        compteValeurs();
    }
};
/*
 * affecte une réponse à un marker et compte le nombre de réponses différentes fournies
 * @param {type} markerID
 * @param {type} valeur
 * @returns {Boolean}
 */
function affecte(markerID, valeur) {
    // on prévient les erreur de lecture de marker
    if (eleves[markerID] === undefined)
        return false;
    var nbvotes = 1;
    if (datas[markerID] === undefined) {
        datas[markerID] = {vote: valeur, nbvotes: nbvotes};
    } else if (datas[markerID].vote !== valeur) {
        nbvotes = datas[markerID].nbvotes + 1;
        datas[markerID] = {vote: valeur, nbvotes: nbvotes};
    }
}
/*
 * met les numéros des élèves qui ont voté en bleu.
 * @returns {undefined}
 */
function updateVotes() {
    for (var i in datas) {
        if (datas[i].nbvotes > 0)
            document.querySelector("#el" + i + " > span:first-of-type").className = "numerobleu";
    }
}
/*
 * crée l'image avec les statistiques des réponses.
 * @param {type} value = la bonne réponse
 * @returns {undefined}
 */
function compteValeurs(value) {
    totaux = {"A": 0, "B": 0, "C": 0, "D": 0};
    var nbvals = 0;
    for (var i in datas) {
        totaux[datas[i].vote]++;
        nbvals++;
    }
    var h = 430;// base des colonnes
    var colorsDefault = {face: "#50D4FD", right: "#3da6c6", top: "#68dbff"};// couleurs par défaut
    var colorsGood = {face: "#66ff33", right: "#4cbf26", top: "#8dff68"};// couleurs par défaut
    var colorsA = colorsDefault, colorsB = colorsDefault, colorsC = colorsDefault, colorsD = colorsDefault;
    context2.clearRect(0, 0, 200, h + 3);
    context2.textAlign = "center";
    var hA = 10 * totaux.A, hB = 10 * totaux.B, hC = 10 * totaux.C, hD = 10 * totaux.D;
    if (value === "A")
        colorsA = colorsGood;
    if (value === "B")
        colorsB = colorsGood;
    if (value === "C")
        colorsC = colorsGood;
    if (value === "D")
        colorsD = colorsGood;
    traceColonne(10, h, hA, colorsA);
    traceColonne(60, h, hB, colorsB);
    traceColonne(110, h, hC, colorsC);
    traceColonne(160, h, hD, colorsD);
    // valeurs
    context2.fillStyle = "#0033cc";
    context2.fillText(totaux.A, 25, h - hA - 10);
    context2.fillText(totaux.B, 75, h - hB - 10);
    context2.fillText(totaux.C, 125, h - hC - 10);
    context2.fillText(totaux.D, 175, h - hD - 10);
    if (nbvals === eleves.effectif)
        scanner(false);
}
function traceColonne(x, h, hx, colors) {
    var dxy = 7;
    context2.fillStyle = colors.face;
    context2.strokeStyle = colors.face;
    context2.fillRect(x, h - hx, 30, hx);
    context2.beginPath();
    context2.fillStyle = colors.right;
    // parallélogramme à droite
    context2.moveTo(x + 30, h);
    context2.lineTo(x + 30 + dxy, h - dxy);
    context2.lineTo(x + 30 + dxy, h - dxy - hx);
    context2.lineTo(x + 30, h - hx);
    context2.closePath();
    context2.fill();
    context2.stroke();
    // parallélogramme en haut
    context2.fillStyle = colors.top;
    context2.beginPath();
    context2.moveTo(x, h - hx);
    context2.lineTo(x + 30, h - hx);
    context2.lineTo(x + 30 + dxy, h - hx - dxy);
    context2.lineTo(x + dxy, h - hx - dxy);
    context2.lineTo(x, h - hx);
    context2.closePath();
    context2.fill();
    context2.stroke();
}
/*
 * créations initiales au chargement de la page web.
 * @returns {undefined}
 */
function onLoad() {
    if (location.href.indexOf("file:") > -1) {
        document.getElementById("btnportable").className = "cache";
    }
    chargeEleves();
    var formule = document.getElementById("demomath");
    katex.render("\\dfrac{n!}{k!(n-k)!} = {^n}C_k", formule, {throwOnError: false, errorColor: "#FFF"});
    if (navigator.mediaDevices.getUserMedia === undefined) {
        navigator.mediaDevices.getUserMedia = function (constraints) {
            var getUserMedia = navigator.webkitGetUserMedia || navigator.mozGetUserMedia;

            if (!getUserMedia) {
                return Promise.reject(new Error('getUserMedia is not implemented in this browser'));
            }
            return new Promise(function (resolve, reject) {
                getUserMedia.call(navigator, constraints, resolve, reject);
            });
        };
    }
    detectCameras();
    detector = new AR.Detector();
    canvas = document.getElementById("surcouche");
    context = canvas.getContext("2d");
    //video = document.getElementById('video');
    canvas2 = document.getElementById("colonnes");
    context2 = canvas2.getContext("2d");
    //canvas2.width = parseInt(canvas2.style.width);
    //canvas2.height = parseInt(canvas2.style.height);
    context2.font = "30px Arial";
    context2.textAlign = "center";
    context2.fillText("A", 25, 460);
    context2.fillText("B", 75, 460);
    context2.fillText("C", 125, 460);
    context2.fillText("D", 175, 460);
    context2.font = "16px Arial";
    // Turn off automatic editor creation first.
    CKEDITOR.disableAutoInline = true;
    setTimeout(lancerReveal, 1000);
    // détection des touches
    document.onkeydown = function (evt) {
        if (evt.altKey) {
            switch (evt.keyCode) {
                case 75: // K
                    userAlea();
                    break;
                case 83:  //S
                    demarrerCamera();
                    break;
                case 73: //I
                    Infos('open');
                    break;
                case 90: //Z
                    pleinEcran();
                    break;
                case 71: //G
                    nextQ();
                    break;
                case 67: //C
                    scanner();
                    break;
                case 86: //V
                    afficheReponses();
                    break;
                case 82: //R
                    initAll();
                    break;
                case 88 : //ALT X
                    addQ();
            }
        }
    };
    liendirect = location.href.indexOf("?url=");
    if (liendirect > 0) {
        paramsLien = getUrlVars();
        if (paramsLien.url !== undefined) {
            loadFile(paramsLien.url);
        } else {
            console.log(paramsLien);
        }
    } else if (storageAvailable('localStorage')) {
        if (localStorage.lastQ !== undefined) {
            document.getElementById('btnrq').className = "";
        }
    }
}
getUrlVars = function () {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    var len = hashes.length;
    for (var i = 0; i < len; i++) {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
};
function lancerReveal() {
    intervaldecompte = setInterval(reveal, 10);
}
/*
 * Cache le div blanc et le logo après 1s. pour simulter un chargement de page.
 * @returns {undefined}
 */
function reveal() {
    var decompte = Number(document.getElementById("intro").style.opacity);
    if (decompte <= 0.001) {
        document.getElementById("intro").style.display = "none";
        clearInterval(intervaldecompte);
    } else {
        document.getElementById("intro").style.opacity = decompte - 0.01;
    }
}
/*
 * Détecte et démarre l'affichage de la camera reliée à l'ordinateur
 * @returns {undefined}
 */
function demarrerCamera() {
    if (videoSources.length === 0) {
        detectCameras();
        return;
    }
    var videoSource = videoSources[selectedSource][0];//deviceId de la camera sélectionnée.
    if (!video) { // pas de video affichée, on lance la machine
        video = document.getElementById("video");
        if (window.stream) {
            window.stream.getTracks().forEach(function(track){
                track.stop();
            });
        }
        var constraints = {video: {
                width: {min: 640, ideal: 1280},
                deviceId: videoSource ? {exact: videoSource} : undefined}
        };
        video.onerror = function(){
          if (videoSources.length > 1) {
            console.log("Erreur de lancement de la vidéo");
              // on affiche le bouton permettant de changer de caméra
              document.getElementById("btnchangecamera").className = "";
              document.getElementById("btnportable").className = "cache";
          }
        };
        navigator.mediaDevices.getUserMedia(constraints)
                .then(function (stream) {
                    // on cache le div d'info sur les caméras détectées
                    document.getElementById("cameras-list").className = "cache";
                    window.stream = stream;
                    if ("srcObject" in video) {
                        video.srcObject = stream;
                    } else {
                        video.src = window.URL.createObjectURL(stream);
                    }
                    canvas.style.opacity = '0.5';
                    tick();
                    // au cas où on aurait branché une nouvelle caméra
                    return navigator.mediaDevices.enumerateDevices();
                })
                .catch(function (err) {
                    console.log(err.name + ": " + err.message);
                });
    } else { // la vidéo était affichée, on coupe le jus
        scanner(false);
        videoReady = false;
        if (window.stream) {
            window.stream.getTracks().forEach(function(track){
                track.stop();
            });
        }
        if (video.srcObject.active)
            video.srcObject.getTracks()[0].stop();
        video = false;
        canvas.width = 0;
        canvas.height = 0;
        if (videoSources.length > 1) {
            document.getElementById("btnchangecamera").className = "cache";
            document.getElementById("btnportable").className = "";
        }
    }
}
function handleError(error) {
    console.log('navigator.getUserMedia error: ', error);
}
function detectCameras() {
    navigator.mediaDevices.enumerateDevices().then(gotVideoDevices).catch(handleError);
}
function gotVideoDevices(deviceInfos) {
    // Handles being called several times to update labels. Preserve values.
    videoSources = [];
    for (var i = 0; i !== deviceInfos.length; ++i) {
        var deviceInfo = deviceInfos[i];
        if (deviceInfo.kind === 'videoinput') {
            var leLabel = deviceInfo.label || "camera " + (videoSources.length + 1);
            videoSources.push([deviceInfo.deviceId, leLabel]);
        }
    }
    var divcameras = document.getElementById("cameras-list");
    if (videoSources.length === 1) {
        selectedSource = 0;
        divcameras.innerHTML = '<b>Une unique caméra</b> détectée, cliquez sur <img src="css/img/32px/camera-web.png" onclick="demarrerCamera();" /> pour afficher l\'image.<br />Ou cliquez <img src="css/img/32px/camera-refresh.png" onclick="detectCameras();" /> après en avoir branché une autre.';
        divcameras.className = 'gris';
        if (storageAvailable('localStorage')) { // on stocke les données localement pour les retrouver à la prochaine ouverture de page
            localStorage.camera = selectedSource;
        }
    } else if (videoSources.length === 0) {
        divcameras.innerHTML = '<b>Pas de caméra</b> détectée, vous pouvez relancer la détection en cliquant <img src="css/img/32px/camera-refresh.png" onclick="detectCameras();" /> après en avoir branché une.<br>Vous pouvez également utiliser un dispositif externe en clianque sur <img src="css/img/32px/phone.png" />.';
        divcameras.className = 'yellow';
        if (storageAvailable('localStorage')) { // on stocke les données localement pour les retrouver à la prochaine ouverture de page
            delete localStorage.camera;
        }
    } else {
      if (localStorage.camera === undefined) {
        selectedSource = 1;// 2e camera.
      }
        divcameras.className = 'gris';
        divcameras.innerHTML = '<b>Plusieurs caméras</b> détectées, la 2e est celle utilisée par défaut, vous pourrez permutter en cliquant sur <img src="css/img/32px/gnome-session-switch.png" /> une fois l\'image affichée. Vous pouvez également sélectionner directement celle que vous voulez utiliser :<br />';
        for (i = 0; i < videoSources.length; i++) {
          divcameras.innerHTML += " <input type='radio' name='cameraRadio' onClick='selectedSource="+i+";' value='"+(i+1)+"' title='"+videoSources[i][1]+"' "+((selectedSource === i)?"checked":"")+"> "+(i+1);
        }
    }
}
function changeCamera() {
    if (videoSources.length === 1)
        return false;//pas la peine de faire quoique ce soit, si une seule caméra
    demarrerCamera();//arrête la vidéo
    if (videoSources.length > 1) {
        selectedSource = (selectedSource + 1) % videoSources.length;
    }
    if (storageAvailable('localStorage')) { // on stocke les données localement pour les retrouver à la prochaine ouverture de page
        localStorage.camera = selectedSource;
    }
    demarrerCamera();//relance la vidéo
}
/*
 * détermine la réponse apportée par la direction(dir) du marker et des coordonnées
 * des coins du marker (vertex)
 *
 */
function derterminateResponse(corners) {
    var reponse;
    var dx = corners[0].x - corners[2].x, dy = corners[0].y - corners[2].y;
    if (dx > 0) {
        if (dy > 0) {
            reponse = "C";
        } else if (dy < 0) {
            reponse = "D";
        }
    } else if (dx < 0) {
        if (dy > 0) {
            reponse = "B";
        } else if (dy < 0) {
            reponse = "A";
        }
    }
    return reponse;
}
/*
 *
 */
function determinateSize(vertex) {
    var lcarre = vertex[0][0] * vertex[0][0] - vertex[1][0] * vertex[1][0] + vertex[0][1] * vertex[0][1] - vertex[1][1] * vertex[1][1];
    var Lcarre = vertex[0][0] * vertex[0][0] - vertex[3][0] * vertex[3][0] + vertex[0][1] * vertex[0][1] - vertex[3][1] * vertex[3][1];
    // si l'un des côtés est inférieur à 10 px, on signale une erreur
    if (lcarre < 100 || Lcarre < 100)
        return false;
    else
        return true;
}
/*
 * Montre les réponses apportées par les élèves.
 * @param value : la réponse correcte (donnée par le prof)
 */
function showResponses(value) {
    for (var i in datas) {
        document.querySelector("#el" + i + " > span:first-of-type").innerHTML = datas[i].vote;
        if (datas[i].vote !== value) {
            document.querySelector("#el" + i + " > span:first-of-type").className = "numerorouge";
        } else {
            document.querySelector("#el" + i + " > span:first-of-type").className = "numerovert";
        }
    }
    return true;
}
/*
 * setGoogAnswer
 * @var : la bonne réponse
 * - Affiche les réponses des élèves dans leur numéro et colore rouge si erreur
 * - colore la colonne de la bonne réponse.
 */
function setGoodAnswer(value) {
    qreponses[qFocusOn] = value;
    showResponses(value);
    compteValeurs(value);
    addStyle(qFocusOn);
    if (sessionId > 0) {
        reponsesChangeDetected = true;
    }
}
function setAnswer(value) {
    if (value !== "0") {
        qreponses[qFocusOn] = value;
        document.getElementById('revealanswer').className = "";
        document.getElementById("goodAnswer").className = "cache";
    } else {
        delete qreponses[qFocusOn];
        document.getElementById('revealanswer').className = "cache";
        document.getElementById("goodAnswer").className = "";
    }
}
function giveGoodAnswer() {
    var value = qreponses[qFocusOn];
    showResponses(value);
    compteValeurs(value);
    addStyle(qFocusOn);
}
/*
 *
 * @returns {undefined}
 */
function addStyle(questionNumber) {
    var s = -1;
    if (document.getElementById("stylesheet" + questionNumber) !== null) {
        removeStyle(questionNumber);
    }
    if (qreponses[questionNumber] === "A")
        s = 1;
    else if (qreponses[questionNumber] === "B")
        s = 2;
    else if (qreponses[questionNumber] === "C")
        s = 3;
    else if (qreponses[questionNumber] === "D")
        s = 4;
    else {
        return false;
    }
    var sheet = document.createElement('style');
    sheet.id = "stylesheet" + questionNumber;
    sheet.innerHTML = "#editor" + questionNumber + " ol > li:nth-child(" + s + ")::before{border-radius:20px 20px 20px 20px;border:3px solid green;}";
    document.body.appendChild(sheet);
    stylesheets[questionNumber] = "sstylesheet" + questionNumber;
}
function removeStyle(questionNumber) {
    var sheet = document.getElementById("stylesheet" + questionNumber);
    var sheetParent = sheet.parentNode;
    sheetParent.removeChild(sheet);
    delete stylesheets[questionNumber];
}
/*
 * récupére les questions sous forme de fichier texte.
 */
function downloadQ() {
    //var content = document.getElementById("animate").innerHTML;
    var content = {};
    var nq = 0;
    for (var name in CKEDITOR.instances) {
        content[nq] = {question: CKEDITOR.instances[name].getData()};
        if (qreponses[nq] !== undefined)
            content[nq].reponse = qreponses[nq];
        nq++;
    }
    content = JSON.stringify(content);
    if (storageAvailable('localStorage')) {
        if (content.length < 3000000) // stockage seulement si taille inférieur à 3Mo environ
            localStorage.lastQ = content;
    }
    var contentType = 'text/plain';
    var filename = "questions.txt";
    var blob = new Blob([content], {type: contentType});
    download(blob, filename, "text/plain");
}
/*
 *
 * Télécharge les participants sur l'ordinateur
 */
function usersDownload() {
    var content = "", i = 0;
    var participants = document.getElementsByClassName("eleve");
    if (participants.length === 0) {
        alert("pas de participant à télécharger.");
        return false;
    }
    for (i = 0; i < participants.length; i++) {
        content += participants[i].childNodes[0].innerHTML + "\t" + participants[i].childNodes[1].innerHTML + "\r\n";
    }
    var contentType = 'text/plain';
    var filename = "participants.txt";
    var blob = new Blob([content], {type: contentType});
    download(blob, filename, "text/plain");
}
/*
 * Télécharge un fichier de id / nom / groupe
 * @param {type} event
 * @returns {false}
 */
function groupsDownload() {
    console.log("yep");
    var content = "", i, j;
    if (college === {}) {
        alert("pas de groupe à télécharger.");
        return false;
    }
    console.log("yop");
    for (i in college) {
        console.log(i);
        if (i === "uploaded")
            continue;
        if (college[i].effectif === undefined)
            continue;
        for (j in college[i]) {
            console.log(j);
            if (j !== "effectif")
                content += j + "\t" + college[i][j] + "\t" + i + "\r\n";
        }
    }
    console.log("youp");
    if (content === "") {
        console.log(content);
        alert("Pas de données à télécharger.");
        return false;
    }

    var contentType = 'text/plain';
    var filename = "participants.txt";
    var blob = new Blob([content], {type: contentType});
    download(blob, filename, "text/plain");
}
/*
 * lit un fichier uploadé depuis le DD et remplace les questions
 */
var openFile = function (event) {
    var input = event.target;
    var reader = new FileReader();
    reader.onload = function () {
        if (storageAvailable('localStorage')) {
            if (reader.result.length < 3000000)
                // on stocke les données localement pour les retrouver à la prochaine ouverture de page à condition qu'il ne dépasse pas 3Mo environ
                localStorage.lastQ = reader.result;
        }
        insereQuestions(reader.result);
    };
    reader.readAsText(input.files[0]);
};
var loadLastQCM = function () {
    if (localStorage.lastQ !== undefined)
        insereQuestions(localStorage.lastQ);
};
/*
 * Récupère un fichier txt depuis une url pour en récupérer les questions
 *
 */
var firstRender = true;
var loadFile = function (url) {
    var reader = new XMLHttpRequest();
    reader.onload = function () {
        insereQuestions(reader.responseText);
        if (firstRender && reader.responseText.indexOf("math-tex") > -1) {
            // on relance l'affichage une deuxième fois, pour les pb d'affichage de latex au premier chargement.
            insereQuestions(reader.responseText);
            firstRender = false;
        }
    };
    reader.open("get", "phploader.php?url=" + url, true);
    reader.send();
    if (myWindow !== undefined) {
        myWindow.close();
    }
};
/*
 * remplace les questions par les données passées en paramètre
 * @param {type} json : chaine à parser de type {0:{"question":"html de la question", "reponse":"A"}}
 * @returns {undefined}
 */
var insereQuestions = function (json) {
    document.getElementById('cacheQuestions').className = "montre";
    document.getElementById('btnrq').className = "cache";
    var questionsreponses = {},i;
    // ancienne version
    if (json.indexOf("|#|") > -1) {
        var qr = json.split("|json|");
        var qs = qr[0].split("|#|");
        if (qr[1] !== undefined)
            qr = JSON.parse(qr[1]);
        else {
            qr = {};
        }
        for (i = 0; i < qs.length; i++) {
            questionsreponses[i] = {"question": qs[i], "reponse": qr[i]};
        }
    } else {
        questionsreponses = JSON.parse(json);
    }
    var elem = document.getElementById("animate");
    qreponses = {};
    elem.innerHTML = "";
    nbQ = 0;
    for (i in questionsreponses) {
        nbQ++;
        if (questionsreponses[i].question !== "")
            elem.innerHTML += '<div id="editor' + i + '" contenteditable="true" class="question">' + questionsreponses[i].question + '</div>';
        if (questionsreponses[i].reponse !== undefined)
            qreponses[Number(i)] = questionsreponses[i].reponse;
    }
    // on cache les options d'édition qui peuvent contenir les réponses...
    document.getElementById("editionquestions").className = "cache";
    document.getElementById("navigation").style.marginTop = "10px";
    reloadCKEDITOR();
    qFocusOn = 0;
    setAnimationWidth();
    updateNav();
    // on réinitialise tous les éléments de réponses
    resetAll();
};
var usersOpenFile = function (event) {
    // le fichier est un txt avec lignes au format Numero\tNom[\tclasse] ou Nom seul
    var input = event.target;
    var reader = new FileReader();
    reader.onload = function () {
        importerParticipants(reader.result);
    };
    reader.readAsText(input.files[0]);
};
var importerParticipants = function (liste) {
    var withClasses = false;
    var nomsClasses = [];
    var compteurIds = 1;
    var users = liste.split(/[\r\n]+/g);// pour que ça marche à partir de fichiers créés avec des systèmes différents de Windows.
    college.uploaded = {effectif: 0};
    for (var i = 0; i < users.length; i++) {
        if (users[i].trim() === "")
            continue;// ligne vide
        var text = users[i].split("\t");
        if (text.length === 3) { // 3e colonne = classe
            withClasses = true;
            if (nomsClasses.indexOf(text[2].trim()) < 0) {
                nomsClasses.push(text[2].trim());
                college[text[2].trim()] = {};
                college[text[2]].effectif = 0;
            }
            college[text[2].trim()][text[0].trim()] = text[1].trim();
            college[text[2]].effectif++;
        } else if (text.length === 1) {
            //on imagine une liste de noms sans numéro
            college.uploaded[compteurIds++] = text[0].trim();
            college.uploaded.effectif++;
        } else {
            college.uploaded[text[0].trim()] = text[1].trim();
            college.uploaded.effectif++;
        }
    }
    if (withClasses) {
        // suppression des classes qui ne sont pas dans la liste des classes chargées
        for (var classe in college) {
            if (nomsClasses.indexOf(classe) < 0) {
                delete college[classe];
            }
        }
        peuplerSelectClasses("new");
        // on montre le bouton permettant de reseter la liste
        document.getElementById("btnresetclasses").className = "";
        if (storageAvailable('localStorage')) { // on stocke les données localement pour les retrouver à la prochaine ouverture de page
            localStorage.college = JSON.stringify(college);
        }
    } else
        chargeClasse("uploaded");
};
var peuplerSelectClasses = function (action) {
    var x = document.getElementById("classes"), option, nomClasse;
    var opts = x.getElementsByTagName('option');
    // on vide le select
    while (opts[1]) {
        x.removeChild(opts[1]);
    }
    // on remplit avec les noms de classes
    for (nomClasse in college) {
        if ((nomClasse !== "uploaded" && nomClasse !== "GP1" && nomClasse !== "GP2" && action === "new") || (action === "basic" && nomClasse !== "uploaded")) {
            option = document.createElement("option");
            option.text = nomClasse;
            option.value = nomClasse;
            x.add(option);
        }
    }
};
/*
 * fillTable : remplit la variable qexport et
 * le tableau d'affichage des résultats des élèves
 */
var fillTable = function () {
    var tableau = document.getElementById("tableau");
    tableau.innerHTML = "";
    //var header = tableau.createTHead();
    //var row = header.insertRow(0);
    var row = tableau.insertRow(0);
    var color = "red";
    var cmptr = 2;
    var cells = [];
    var i;
    // si les datas de la question en cours existent, on les mets dans l'objet qui va être parcouru
    if (datas !== undefined)
        qdatas[qFocusOn] = datas;
    qexport = '"id"\t"Nom"';
    cells.push("id");
    cells.push("Nom");
    for (i = 0; i < nbQ; i++) {
        // ligne des question
        // ideleve;nom élève;Q1;...
        qexport += '\t"Q' + (i + 1) + '"';
        cells.push("Q" + (i + 1));
    }
    qexport += '\t"Score"';
    cells.push("score");
    completeEntete(cells, row);
    // ligne des bonnes réponses
    row = tableau.insertRow(1);
    cells = ["", "<i>Bonne réponse</i>"];
    qexport += '\r\n""\t"Bonne réponse"';
    for (i = 0; i < nbQ; i++) {
        qexport += "\t";
        if (qreponses[i] !== undefined && qdatas[i] !== undefined) {
            // on n'affiche pas la réponse s'il n'y a pas eu de sondage effectué
            qexport += qreponses[i];
            cells.push("<b>" + qreponses[i] + "</b>");
        } else
            cells.push("");
    }
    completeLigne(cells, row);
    for (i in eleves) {
        if (i === "effectif")
            continue;
        var score = 0;
        cells = [i, eleves[i]];
        qexport += "\r\n" + i + "\t" + '"' + eleves[i] + '"';
        for (var j = 0; j < nbQ; j++) {
            qexport += "\t";
            if (qdatas[j] === undefined) {
                qexport += "\t";
                cells.push("");
                continue;
            }
            if (qdatas[j][Number(i)] !== undefined) {
                qexport += '"' + qdatas[j][i].vote + '"';
                if (qreponses[j] !== undefined) {
                    if (qreponses[j] === qdatas[j][i].vote) {
                        score++;
                        color = "green";
                    } else
                        color = "red";
                }
                cells.push("<span class='text-" + color + "'>" + qdatas[j][i].vote + "</span>");
            } else {
                cells.push("");
            }
        }
        qexport += "\t" + score;
        cells.push(score);
        row = tableau.insertRow(cmptr);
        completeLigne(cells, row);
        cmptr++;
    }
    // création des liens pour le tri
    var entetes = document.querySelectorAll("#tableau th");
    for (var k = 0; k < entetes.length; k++) {
        entetes[k].onclick = sortTable(k);
    }
};
var afficherStats = function () {
    var divResults = document.getElementById("resultats");
    if (divResults.className === "cache responsive") {
        // création du fichier et remplissage du tableau
        fillTable();
        // on affiche la page
        divResults.className = "responsive";
    } else {
        divResults.className = "cache responsive";
    }
};
function completeLigne(cells, row) {
    var cel;
    for (var i = 0; i < cells.length; i++) {
        cel = row.insertCell(i);
        cel.innerHTML = cells[i];
    }
}
function completeEntete(cells, row) {
    var cel;
    for (var i = 0; i < cells.length; i++) {
        cel = document.createElement("TH");
        cel.innerHTML = cells[i];
        row.appendChild(cel);
    }
}
function telechargerStats() {
    if (qexport === "")
        return false;
    var contentType = 'text/plain';
    var filename = "resultats.csv";
    var blob = new Blob([qexport], {type: contentType});
    download(blob, filename, "text/plain");
}
/*
 * Ouvre la fenêtre de bibliothèque
 * @returns {undefined}
 */
function openLibrary() {
    if (myWindow === undefined)
        myWindow = window.open("bibliotheque.html", "QCMCamLibrary", "menubar=no,status=no,toolbar=no,scrollbars=yes");
    else if (myWindow.closed) {
        myWindow = window.open("bibliotheque.html", "QCMCamLibrary", "menubar=no,status=no,toolbar=no,scrollbars=yes");
        myWindow.focus();
    } else {
        myWindow.focus();
    }
}
function closeLibrary() {
    if (myWindow !== undefined)
        myWindow.close();
}
function isNumeric(value) {
    return /^-{0,1}\d+$/.test(value);
}
function sortTable(n) {
    var table, rows, switching, i, x, y, shouldSwitch, dir, switchcount = 0;
    table = document.getElementById("tableau");
    switching = true;
    // Set the sorting direction to ascending:
    dir = "asc";
    /* Make a loop that will continue until
     no switching has been done: */
    while (switching) {
        // Start by saying: no switching is done:
        switching = false;
        rows = table.getElementsByTagName("TR");
        /* Loop through all table rows (except the
         first, which contains table headers): */
        for (i = 2; i < (rows.length - 1); i++) {
            // Start by saying there should be no switching:
            shouldSwitch = false;
            /* Get the two elements you want to compare,
             one from current row and one from the next: */
            x = rows[i].getElementsByTagName("TD")[n];
            y = rows[i + 1].getElementsByTagName("TD")[n];
            /* Check if the two rows should switch place,
             based on the direction, asc or desc: */
            if (dir === "asc") {
                if (isNumeric(x.innerHTML) && isNumeric(y.innerHTML))
                {
                    if (Number(x.innerHTML) > Number(y.innerHTML)) {
                        shouldSwitch = true;
                        break;
                    }
                } else
                if (x.innerHTML.toLowerCase() > y.innerHTML.toLowerCase()) {
                    // If so, mark as a switch and break the loop:
                    shouldSwitch = true;
                    break;
                }
            } else if (dir === "desc") {
                if (isNumeric(x.innerHTML) && isNumeric(y.innerHTML))
                {
                    if (Number(x.innerHTML) < Number(y.innerHTML)) {
                        shouldSwitch = true;
                        break;
                    }
                } else
                if (x.innerHTML.toLowerCase() < y.innerHTML.toLowerCase()) {
                    // If so, mark as a switch and break the loop:
                    shouldSwitch = true;
                    break;
                }
            }
        }
        if (shouldSwitch) {
            /* If a switch has been marked, make the switch
             and mark that a switch has been done: */
            rows[i].parentNode.insertBefore(rows[i + 1], rows[i]);
            switching = true;
            // Each time a switch is done, increase this count by 1:
            switchcount++;
        } else {
            /* If no switching has been done AND the direction is "asc",
             set the direction to "desc" and run the while loop again. */
            if (switchcount === 0 && dir === "asc") {
                dir = "desc";
                switching = true;
            }
        }
    }
}
/*
 * Récupère un fichier txt depuis une url pour en récupérer le numéro de fichier d'échange
 *
 */
var loadSession = function () {
    if (location.href.indexOf("file:") > -1) {
        alert('Fonctionnement immpossible sans serveur web.');
        return false;
    }
    // on ne peut pas travailler sans avoir chargé une classe
    if (eleves.effectif === undefined) {
        alert("Vous devez avoir importé une classe et les questions avant de lancer le scan.");
        return false;
    }
    if (nbQ === 1) {
        var rep = confirm('Une seule question proposée, continuer ?\n(non : Annuler, oui : OK)');
        if (!rep)
            return false;
    }
    // si une session existe déjà, on la reprend
    if (sessionId !== undefined) {
        deporterScan();
        return;
    }
    var reader = new XMLHttpRequest();
    reader.onload = function () {
        var rep = JSON.parse(reader.responseText);
        if (rep.connexion === "failed") {
            document.getElementById("lienqr").innerHTML = "<span class='text-red'>Echec de connexion au serveur</span>";
            return false;
        }
        sessionId = rep.id;
        document.getElementById("btnportable").className = "cache";
        document.getElementById("btnstopportable").className = "";
        deporterScan();
    };
    reader.open("get", "sessionapp.php", true);
    reader.send();
};
var deporterScan = function () {
    // sessionId est le numéro de session disponible sur le serveur, il servira ensuite pour tous les échanges jusqu'au prochain rechargement de la page principale de qcmcam.
    // on affiche le qrcode à lire avec le smartphone
    var urlappli = window.location.protocol + "//" + window.location.host + window.location.pathname.slice(0, -10) + ((window.location.port !== "") ? ":" + window.location.port : "");
    var url = urlappli + "/p.html?s=" + sessionId;
    // Affichage du QRCode (c)
    document.getElementById('qrious').className = "montre";
    var qr = new QRious({
        element: document.getElementById('qrious'),
        size: 200,
        value: url
    });
    // Pour debug la partie déportée
    //document.getElementById("lienqr").innerHTML = '<a href="' + url + '">' + sessionId + '</a>';
    // on cache le div d'info sur les caméras détectées
    document.getElementById("cameras-list").className = "cache";
    // on envoie la liste des numéros d'id d'élèves, le nombre de questions et la question en cours.
    var ids = {};
    for (var i in eleves) {
        if (i !== "effectif") {
            ids[i] = i;
        }
    }
    var datas = {ids: ids, reps: qreponses, nbq: nbQ, qFocusOn: qFocusOn};
    var reader = new XMLHttpRequest();
    reader.onload = function () {
        return true;
    };
    reader.open("get", "sessionapp.php?s=" + sessionId + "&json=" + JSON.stringify(datas), true);
    reader.send();
    // on lance un appel répété de la lecture du fichier de session toutes les 3 secondes;
    if (sessionId !== undefined && intervalSession === undefined) {
        intervalSession = setTimeout(getSessionData, 2333);
    }
};
var stopSession = function () {
    document.getElementById("btnportable").className = "";
    document.getElementById("btnstopportable").className = "cache";
    stopSessionRequest = true;
};
// lecture des infos mises à jour par le smartphone
var getSessionData = function () {
    var json = {};
    if (usersChangeDetected) {
        json.ids = {};
        for (var i in eleves) {
            if (i !== "effectif") {
                json.ids[i] = i;
            }
        }
        usersChangeDetected = false;
        wait.updateClasse = true;
    }
    if (changeQuestionFocus) {
        json.qFocusOn = qFocusOn;
        changeQuestionFocus = false;
        if (reponseAction !== "nexted")
            wait.nexted = true;
    }
    if (changeNombreQuestions) {
        json.nbq = nbQ;
        changeNombreQuestions = false;
        wait.addQuestion = true;
    }
    if (reponsesChangeDetected) {
        json.reps = qreponses;
        reponsesChangeDetected = false;
    }
    if (reponseAction !== undefined) {
        json.ok = reponseAction;
        reponseAction = undefined;
    }
    if (stopSessionRequest) {
        json.stopSession = true;
    }
    var reader = new XMLHttpRequest();
    reader.onload = function () {
        if (reader.responseText !== "") {
            // on sépare les lignes de réponse
            var lignesjson = reader.responseText.split("\n");
            var repjson;
            for (var i = 0; i < lignesjson.length; i++) {
                if (lignesjson[i] !== "") {
                    repjson = JSON.parse(lignesjson[i]);
                    if (repjson.ok === "received") {
                        if (document.getElementById('qrious').className === "montre") {
                            document.getElementById('qrious').className = "cache";
                            document.getElementById("lienqr").innerHTML = "";
                        }
                        // on enlève le cache gris des question si présent
                        if (document.getElementById("cacheQuestions").className === "montre")
                            document.getElementById("cacheQuestions").className = "cache";
                    }
                    // on empêche la récupération de données si il y a eu un chamgement qui implique une réinitialisation des datas.
                    if (repjson.nexted !== undefined) {
                        wait.nexted = false;
                    }
                    if (repjson.chgQuestion !== undefined) {
                        wait.chgQuestion = false;
                    }
                    if (repjson.updateClasse !== undefined) {
                        wait.updateClasse = false;
                    }
                    // si on attend la réponse d'un changement envoyé au dispositif, on ne récupère surtout pas les données de réponse
                    if (wait.nexted || wait.chgQuestion || wait.updateClasse)
                        delete repjson.datas;
                    setReponses(repjson);
                }
            }
        }
        // en cas de demande d'arrêt de la session on arrête l'échange de données avec le serveur
        if (stopSessionRequest) {
            stopSessionRequest = false;
            return;
        }
        intervalSession = setTimeout(getSessionData, 2333);
    };
    reader.open("get", "sessionapp.php?s=" + sessionId + "&json=" + JSON.stringify(json), true);
    reader.send();
};
// Mise à jour des réponses après réception des données du smartphone
// lesDAtas : json
var setReponses = function (lesDatas) {
    var dataUpdated = false;
    for (var i in lesDatas.datas) {
        if (lesDatas.datas[i] !== undefined) {
            affecte(Number(i), lesDatas.datas[i]);
            dataUpdated = true;
        }
    }
    if (dataUpdated) {
        updateVotes();
        compteValeurs();
    }
    if (lesDatas.action !== undefined) {
        if (lesDatas.action === "end") {
            reponseAction = "ended";
            return true;
        } else if (lesDatas.action === "next") {
            nextQ();
            afficheReponses(false);
            reponseAction = "nexted";
        } else if (lesDatas.action === "stats") {
            afficheReponses();
            reponseAction = "statsed";
        } else if (lesDatas.action === "correct") {
            giveGoodAnswer();
            reponseAction = "corrected";
        } else if (lesDatas.action === "reset") {
            initAll(false);
            reponseAction = "reseted";
        }
    }
}
;
window.onload = onLoad;
